#include "../fake.h"

#ifdef __cplusplus
extern "C" {
#endif

#ifndef _di_fake_print_operation_all_complete_
  f_status_t fake_print_operation_all_complete(fl_print_t * const print) {

    if (!print) return F_status_set_error(F_output_not);
    if (print->verbosity < f_console_verbosity_normal_e) return F_output_not;

    f_file_stream_lock(print->to);

    fl_print_format("%rAll operations complete.%r", print->to, f_string_eol_s, f_string_eol_s);

    f_file_stream_flush(print->to);
    f_file_stream_unlock(print->to);

    return F_okay;
  }
#endif // _di_fake_print_operation_all_complete_

#ifndef _di_fake_print_operation_cancelled_
  f_status_t fake_print_operation_cancelled(fl_print_t * const print, const uint8_t operation) {

    if (!print) return F_status_set_error(F_output_not);
    if (print->verbosity < f_console_verbosity_normal_e) return F_output_not;

    f_file_stream_lock(print->to);

    fl_print_format("%[The operation '%]%[", print->to, print->context, print->context, print->notable);

    if (operation == fake_operation_build_e) {
      f_print_dynamic(fake_other_operation_build_s, print->to);
    }
    else if (operation == fake_operation_clean_e) {
      f_print_dynamic(fake_other_operation_clean_s, print->to);
    }
    else if (operation == fake_operation_make_e) {
      f_print_dynamic(fake_other_operation_make_s, print->to);
    }
    else if (operation == fake_operation_skeleton_e) {
      f_print_dynamic(fake_other_operation_skeleton_s, print->to);
    }

    fl_print_format("%]%[' is cancelled.%]%r", print->to, print->notable, print->context, print->context, f_string_eol_s);

    f_file_stream_flush(print->to);
    f_file_stream_unlock(print->to);

    return F_okay;
  }
#endif // _di_fake_print_operation_cancelled_

#ifdef __cplusplus
} // extern "C"
#endif
